blob: 96ecb2963d0c5d13e4dbc4f1567541768580a332 [file] [log] [blame]
Ollie Lho184a4042005-11-26 21:55:36 +00001#
Uwe Hermannf78cff12009-06-12 14:05:25 +00002# This file is part of the flashrom project.
3#
4# Copyright (C) 2005 coresystems GmbH <stepan@coresystems.de>
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +00005# Copyright (C) 2009,2010,2012 Carl-Daniel Hailfinger
Uwe Hermannf78cff12009-06-12 14:05:25 +00006#
7# This program is free software; you can redistribute it and/or modify
8# it under the terms of the GNU General Public License as published by
9# the Free Software Foundation; version 2 of the License.
10#
11# This program is distributed in the hope that it will be useful,
12# but WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14# GNU General Public License for more details.
15#
Ronald G. Minnich5e5f75e2002-01-29 18:21:41 +000016
Thomas Heijligen90fa8152021-09-25 13:39:42 +020017include Makefile.include
18
Ollie Lho184a4042005-11-26 21:55:36 +000019PROGRAM = flashrom
Ronald G. Minnicheaab50b2003-09-12 22:41:53 +000020
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +000021###############################################################################
22# Defaults for the toolchain.
23
24# If you want to cross-compile, just run e.g.
25# make CC=i586-pc-msdosdjgpp-gcc
26# You may have to specify STRIP/AR/RANLIB as well.
Carl-Daniel Hailfingerb7bce8a2012-08-14 21:36:11 +000027#
28# Note for anyone editing this Makefile: gnumake will happily ignore any
29# changes in this Makefile to variables set on the command line.
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +000030STRIP ?= strip
Christian Ruppertdb9d9f42009-05-14 14:17:07 +000031INSTALL = install
Paul Fox05dfbe62009-06-16 21:08:06 +000032DIFF = diff
Christian Ruppertdb9d9f42009-05-14 14:17:07 +000033PREFIX ?= /usr/local
Uwe Hermann56b2cb02009-05-21 15:59:58 +000034MANDIR ?= $(PREFIX)/share/man
Nico Huber9e2dc2f2018-12-23 22:00:47 +010035CFLAGS ?= -Os -Wall -Wextra -Wno-unused-parameter -Wshadow -Wmissing-prototypes -Wwrite-strings
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +000036EXPORTDIR ?= .
Patrick Georgi97bc95c2011-03-08 07:17:44 +000037RANLIB ?= ranlib
Stefan Tauner3f73ffe2016-01-07 17:45:59 +000038PKG_CONFIG ?= pkg-config
39BUILD_DETAILS_FILE ?= build_details.txt
Stefan Taunerbe62d3f2015-01-10 09:32:44 +000040
Stefan Taunerfd0d4132012-09-25 21:24:55 +000041# The following parameter changes the default programmer that will be used if there is no -p/--programmer
42# argument given when running flashrom. The predefined setting does not enable any default so that every
43# user has to declare the programmer he wants to use on every run. The rationale for this to be not set
44# (to e.g. the internal programmer) is that forgetting to specify this when working with another programmer
45# easily puts the system attached to the default programmer at risk (e.g. you want to flash coreboot to another
46# system attached to an external programmer while the default programmer is set to the internal programmer, and
47# you forget to use the -p parameter. This would (try to) overwrite the existing firmware of the computer
48# running flashrom). Please do not enable this without thinking about the possible consequences. Possible
Thomas Heijligen84e9c912021-06-01 16:22:14 +020049# values can be found when running 'flashrom --list-supported' under the 'Supported programmers' section.
50CONFIG_DEFAULT_PROGRAMMER_NAME ?=
Stefan Tauner265fcac2014-06-02 00:12:23 +000051# The following adds a default parameter for the default programmer set above (only).
Thomas Heijligen84e9c912021-06-01 16:22:14 +020052CONFIG_DEFAULT_PROGRAMMER_ARGS ?=
Stefan Tauner265fcac2014-06-02 00:12:23 +000053# Example: compiling with
Thomas Heijligen84e9c912021-06-01 16:22:14 +020054# make CONFIG_DEFAULT_PROGRAMMER_NAME=serprog CONFIG_DEFAULT_PROGRAMMER_ARGS="dev=/dev/ttyUSB0:1500000"
Stefan Tauner265fcac2014-06-02 00:12:23 +000055# would make executing './flashrom' (almost) equivialent to './flashrom -p serprog:dev=/dev/ttyUSB0:1500000'.
Christian Ruppertdb9d9f42009-05-14 14:17:07 +000056
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +000057# If your compiler spits out excessive warnings, run make WARNERROR=no
58# You shouldn't have to change this flag.
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +000059WARNERROR ?= yes
60
61ifeq ($(WARNERROR), yes)
62CFLAGS += -Werror
63endif
64
Stefan Taunere37735a2015-01-26 22:03:35 +000065ifdef LIBS_BASE
Stefan Taunere37735a2015-01-26 22:03:35 +000066PKG_CONFIG_LIBDIR ?= $(LIBS_BASE)/lib/pkgconfig
Stefan Tauner45207062016-02-19 08:17:24 +000067override CPPFLAGS += -I$(LIBS_BASE)/include
68override LDFLAGS += -L$(LIBS_BASE)/lib -Wl,-rpath -Wl,$(LIBS_BASE)/lib
Stefan Taunere37735a2015-01-26 22:03:35 +000069endif
Stefan Taunerbe62d3f2015-01-10 09:32:44 +000070
Stefan Taunerbfb067b2016-01-07 18:13:07 +000071ifeq ($(CONFIG_STATIC),yes)
Stefan Tauner45207062016-02-19 08:17:24 +000072override PKG_CONFIG += --static
73override LDFLAGS += -static
Stefan Taunerbfb067b2016-01-07 18:13:07 +000074endif
75
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000076# Set LC_ALL=C to minimize influences of the locale.
77# However, this won't work for the majority of relevant commands because they use the $(shell) function and
Martin Rothf6c1cb12022-03-15 10:55:25 -060078# GNU make does not relay variables exported within the makefile to their environment.
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000079LC_ALL=C
80export LC_ALL
81
Stefan Tauner3f73ffe2016-01-07 17:45:59 +000082dummy_for_make_3_80:=$(shell printf "Build started on %s\n\n" "$$(date)" >$(BUILD_DETAILS_FILE))
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000083
84# Provide an easy way to execute a command, print its output to stdout and capture any error message on stderr
85# in the build details file together with the original stdout output.
Pyry Kontio89cc73b2020-07-06 12:57:35 +090086debug_shell = $(shell export LC_ALL=C ; { echo 'exec: export LC_ALL=C ; { $(subst ','\'',$(1)) ; }' >&2; \
87 { $(1) ; } | tee -a $(BUILD_DETAILS_FILE) ; echo >&2 ; } 2>>$(BUILD_DETAILS_FILE))
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000088
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +000089###############################################################################
Nico Huber7f898972021-06-27 13:30:50 +020090# Dependency handling.
91
92DEPENDS_ON_SERIAL := \
93 CONFIG_BUSPIRATE_SPI \
94 CONFIG_PONY_SPI \
95 CONFIG_SERPROG \
96
97DEPENDS_ON_BITBANG_SPI := \
Nico Huber29c68342021-06-27 14:34:16 +020098 CONFIG_DEVELOPERBOX_SPI \
Nico Huber7f898972021-06-27 13:30:50 +020099 CONFIG_INTERNAL \
100 CONFIG_NICINTEL_SPI \
101 CONFIG_OGP_SPI \
102 CONFIG_PONY_SPI \
103 CONFIG_RAYER_SPI \
104
105DEPENDS_ON_LIBPCI := \
106 CONFIG_ATAHPT \
107 CONFIG_ATAPROMISE \
108 CONFIG_ATAVIA \
109 CONFIG_DRKAISER \
110 CONFIG_GFXNVIDIA \
111 CONFIG_INTERNAL \
112 CONFIG_IT8212 \
113 CONFIG_NIC3COM \
114 CONFIG_NICINTEL \
115 CONFIG_NICINTEL_EEPROM \
116 CONFIG_NICINTEL_SPI \
117 CONFIG_NICNATSEMI \
118 CONFIG_NICREALTEK \
119 CONFIG_OGP_SPI \
120 CONFIG_SATAMV \
121 CONFIG_SATASII \
122
123DEPENDS_ON_LIBUSB1 := \
124 CONFIG_CH341A_SPI \
125 CONFIG_DEDIPROG \
126 CONFIG_DEVELOPERBOX_SPI \
127 CONFIG_DIGILENT_SPI \
128 CONFIG_PICKIT2_SPI \
129 CONFIG_RAIDEN_DEBUG_SPI \
130 CONFIG_STLINKV3_SPI \
Jean THOMASe28d8e42022-10-11 17:54:30 +0200131 CONFIG_DIRTYJTAG_SPI \
Nico Huber7f898972021-06-27 13:30:50 +0200132
133DEPENDS_ON_LIBFTDI := \
134 CONFIG_FT2232_SPI \
135 CONFIG_USBBLASTER_SPI \
136
137DEPENDS_ON_LIBJAYLINK := \
138 CONFIG_JLINK_SPI \
139
Nico Hubera54f5a42021-06-27 14:27:41 +0200140
141ifeq ($(CONFIG_ENABLE_LIBUSB1_PROGRAMMERS), no)
142$(call disable_all,$(DEPENDS_ON_LIBUSB1))
143endif
144
145ifeq ($(CONFIG_ENABLE_LIBPCI_PROGRAMMERS), no)
146$(call disable_all,$(DEPENDS_ON_LIBPCI))
147endif
148
Nico Huber7f898972021-06-27 13:30:50 +0200149###############################################################################
Stefan Tauner037cd842013-08-25 00:10:56 +0000150# General OS-specific settings.
151# 1. Prepare for later by gathering information about host and target OS
152# 2. Set compiler flags and parameters according to OSes
153# 3. Likewise verify user-supplied CONFIG_* variables.
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000154
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000155# HOST_OS is only used to work around local toolchain issues.
Stefan Tauner037cd842013-08-25 00:10:56 +0000156HOST_OS ?= $(shell uname)
Miklós Mártona75a2ed2018-01-30 20:25:00 +0100157ifeq ($(findstring MINGW, $(HOST_OS)), MINGW)
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000158# Explicitly set CC = gcc on MinGW, otherwise: "cc: command not found".
159CC = gcc
160endif
Miklós Mártona75a2ed2018-01-30 20:25:00 +0100161
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000162ifneq ($(HOST_OS), SunOS)
Adam Kaufman064b1f22007-02-06 19:47:50 +0000163STRIP_ARGS = -s
164endif
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000165
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000166# Determine the destination OS.
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000167# IMPORTANT: The following line must be placed before TARGET_OS is ever used
168# (of course), but should come after any lines setting CC because the line
169# below uses CC itself.
Pyry Kontio89cc73b2020-07-06 12:57:35 +0900170override TARGET_OS := $(strip $(call debug_shell,$(CC) $(CPPFLAGS) -E os.h 2>/dev/null \
171 | tail -1 | cut -f 2 -d'"'))
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000172
173ifeq ($(TARGET_OS), Darwin)
Stefan Tauner45207062016-02-19 08:17:24 +0000174override CPPFLAGS += -I/opt/local/include -I/usr/local/include
175override LDFLAGS += -L/opt/local/lib -L/usr/local/lib
Stefan Reinauerf79edb92009-01-26 01:23:31 +0000176endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000177
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000178ifeq ($(TARGET_OS), FreeBSD)
Stefan Tauner45207062016-02-19 08:17:24 +0000179override CPPFLAGS += -I/usr/local/include
180override LDFLAGS += -L/usr/local/lib
Andriy Gapon65c1b862008-05-22 13:22:45 +0000181endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000182
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000183ifeq ($(TARGET_OS), OpenBSD)
Stefan Tauner45207062016-02-19 08:17:24 +0000184override CPPFLAGS += -I/usr/local/include
185override LDFLAGS += -L/usr/local/lib
Carl-Daniel Hailfingerb63b0672010-07-02 17:12:50 +0000186endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000187
Stefan Taunerc65b8552013-09-12 15:48:39 +0000188ifeq ($(TARGET_OS), NetBSD)
Nico Huberc0e1c4b2022-12-13 21:55:22 +0000189# Needs special `pciutils/pci.h` for older NetBSD packages
190PCIUTILS_PCI_H := $(shell [ -f /usr/pkg/include/pciutils/pci.h ] && echo -DPCIUTILS_PCI_H)
191override CPPFLAGS += -I/usr/pkg/include $(PCIUTILS_PCI_H)
Stefan Tauner45207062016-02-19 08:17:24 +0000192override LDFLAGS += -L/usr/pkg/lib
Stefan Taunerc65b8552013-09-12 15:48:39 +0000193endif
194
195ifeq ($(TARGET_OS), DragonFlyBSD)
Stefan Tauner45207062016-02-19 08:17:24 +0000196override CPPFLAGS += -I/usr/local/include
197override LDFLAGS += -L/usr/local/lib
Stefan Taunerc65b8552013-09-12 15:48:39 +0000198endif
199
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000200ifeq ($(TARGET_OS), DOS)
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000201EXEC_SUFFIX := .exe
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000202# DJGPP has odd uint*_t definitions which cause lots of format string warnings.
Stefan Tauner45207062016-02-19 08:17:24 +0000203override CFLAGS += -Wno-format
Stefan Tauner449abe22013-09-11 23:34:57 +0000204LIBS += -lgetopt
Nico Huberba681962021-06-27 13:39:23 +0200205# Missing serial support.
206$(call mark_unsupported,$(DEPENDS_ON_SERIAL))
207# Libraries not available for DOS
208$(call mark_unsupported,$(DEPENDS_ON_LIBUSB1) $(DEPENDS_ON_LIBFTDI) $(DEPENDS_ON_LIBJAYLINK))
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000209endif
Ollie Lho184a4042005-11-26 21:55:36 +0000210
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000211# FIXME: Should we check for Cygwin/MSVC as well?
212ifeq ($(TARGET_OS), MinGW)
213EXEC_SUFFIX := .exe
Uwe Hermannd5e85d62011-07-03 19:44:12 +0000214# MinGW doesn't have the ffs() function, but we can use gcc's __builtin_ffs().
Carl-Daniel Hailfingera8da2242012-08-15 23:06:32 +0000215FLASHROM_CFLAGS += -Dffs=__builtin_ffs
Carl-Daniel Hailfinger11990da2013-07-13 23:21:05 +0000216# Some functions provided by Microsoft do not work as described in C99 specifications. This macro fixes that
Stefan Tauner23e10b82016-01-23 16:16:49 +0000217# for MinGW. See http://sourceforge.net/p/mingw-w64/wiki2/printf%20and%20scanf%20family/ */
Carl-Daniel Hailfinger11990da2013-07-13 23:21:05 +0000218FLASHROM_CFLAGS += -D__USE_MINGW_ANSI_STDIO=1
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100219
Uwe Hermannd5e85d62011-07-03 19:44:12 +0000220# For now we disable all PCI-based programmers on Windows/MinGW (no libpci).
Nico Huberca621782021-06-27 13:53:49 +0200221$(call mark_unsupported,$(DEPENDS_ON_LIBPCI))
222# And programmers that need raw access.
223$(call mark_unsupported,CONFIG_RAYER_SPI)
Uwe Hermannd5e85d62011-07-03 19:44:12 +0000224
Nico Huberca621782021-06-27 13:53:49 +0200225else # No MinGW
226
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100227# NI USB-845x only supported on Windows at the moment
Nico Huberca621782021-06-27 13:53:49 +0200228$(call mark_unsupported,CONFIG_NI845X_SPI)
229
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100230endif
231
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000232ifeq ($(TARGET_OS), libpayload)
Stefan Tauner8e19b042013-08-28 09:55:04 +0000233ifeq ($(MAKECMDGOALS),)
234.DEFAULT_GOAL := libflashrom.a
235$(info Setting default goal to libflashrom.a)
236endif
Carl-Daniel Hailfingera8da2242012-08-15 23:06:32 +0000237FLASHROM_CFLAGS += -DSTANDALONE
Nico Huber71331032021-06-27 14:00:39 +0200238$(call mark_unsupported,CONFIG_DUMMY)
Stefan Taunere0168262016-02-21 11:18:24 +0000239# libpayload does not provide the romsize field in struct pci_dev that the atapromise code requires.
Nico Huber71331032021-06-27 14:00:39 +0200240$(call mark_unsupported,CONFIG_ATAPROMISE)
Carl-Daniel Hailfinger11990da2013-07-13 23:21:05 +0000241# Bus Pirate, Serprog and PonyProg are not supported with libpayload (missing serial support).
Nico Huber71331032021-06-27 14:00:39 +0200242$(call mark_unsupported,CONFIG_BUSPIRATE_SPI CONFIG_SERPROG CONFIG_PONY_SPI)
Daniel Thompson45e91a22018-06-04 13:46:29 +0100243# Dediprog, Developerbox, USB-Blaster, PICkit2, CH341A and FT2232 are not supported with libpayload (missing libusb support).
Nico Huber71331032021-06-27 14:00:39 +0200244$(call mark_unsupported,$(DEPENDS_ON_LIBUSB1) $(DEPENDS_ON_LIBFTDI) $(DEPENDS_ON_LIBJAYLINK))
Patrick Georgi97bc95c2011-03-08 07:17:44 +0000245endif
246
Nico Huberdc8e54a2021-06-27 14:17:34 +0200247# Android is handled internally as separate OS, but it supports about the same drivers as Linux.
248ifeq ($(filter $(TARGET_OS),Linux Android), )
249$(call mark_unsupported,CONFIG_LINUX_MTD CONFIG_LINUX_SPI)
250$(call mark_unsupported,CONFIG_MSTARDDC_SPI)
Carl-Daniel Hailfinger601f4cd2016-02-28 22:04:51 +0000251endif
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000252
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000253ifeq ($(TARGET_OS), Android)
Nico Huberdc8e54a2021-06-27 14:17:34 +0200254# Android on x86 (currently) does not provide raw PCI port I/O operations.
255$(call mark_unsupported,CONFIG_RAYER_SPI)
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000256endif
257
Stefan Tauner037cd842013-08-25 00:10:56 +0000258###############################################################################
259# General architecture-specific settings.
260# Like above for the OS, below we verify user-supplied options depending on the target architecture.
261
Uwe Hermann44ffd582011-08-20 14:16:00 +0000262# Determine the destination processor architecture.
263# IMPORTANT: The following line must be placed before ARCH is ever used
264# (of course), but should come after any lines setting CC because the line
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000265# below uses CC itself.
Pyry Kontio89cc73b2020-07-06 12:57:35 +0900266override ARCH := $(strip $(call debug_shell,$(CC) $(CPPFLAGS) -E archtest.c 2>/dev/null \
267 | tail -1 | cut -f 2 -d'"'))
268override ENDIAN := $(strip $(call debug_shell,$(CC) $(CPPFLAGS) -E endiantest.c 2>/dev/null \
269 | tail -1))
Uwe Hermann44ffd582011-08-20 14:16:00 +0000270
Nico Huberc8801732017-12-01 18:19:43 +0000271# Disable the internal programmer on unsupported architectures (everything but x86 and mipsel)
272ifneq ($(ARCH)-little, $(filter $(ARCH),x86 mips)-$(ENDIAN))
Nico Huber8945b812021-06-27 14:24:53 +0200273$(call mark_unsupported,CONFIG_INTERNAL)
Nico Huberc8801732017-12-01 18:19:43 +0000274endif
275
Stefan Taunerfb2d77c2015-02-10 08:03:10 +0000276# PCI port I/O support is unimplemented on PPC/MIPS/SPARC and unavailable on ARM.
David Hendricksb286da72012-02-13 00:35:35 +0000277# Right now this means the drivers below only work on x86.
278ifneq ($(ARCH), x86)
Nico Huber8945b812021-06-27 14:24:53 +0200279$(call mark_unsupported,CONFIG_NIC3COM CONFIG_NICREALTEK CONFIG_NICNATSEMI)
280$(call mark_unsupported,CONFIG_RAYER_SPI CONFIG_ATAHPT CONFIG_ATAPROMISE)
281$(call mark_unsupported,CONFIG_SATAMV)
Uwe Hermann21b10c62011-07-29 12:13:01 +0000282endif
283
Nico Huber8945b812021-06-27 14:24:53 +0200284# Additionally disable all drivers needing raw access (memory, PCI, port I/O)
285# on architectures with unknown raw access properties.
Carl-Daniel Hailfinger8d0d53f2016-02-25 20:10:26 +0000286# Right now those architectures are alpha hppa m68k sh s390
Rosen Penev34d07f02019-07-02 00:14:01 -0700287ifneq ($(ARCH),$(filter $(ARCH),x86 mips ppc arm sparc arc))
Nico Huber8945b812021-06-27 14:24:53 +0200288$(call mark_unsupported,CONFIG_GFXNVIDIA CONFIG_SATASII CONFIG_ATAVIA)
289$(call mark_unsupported,CONFIG_DRKAISER CONFIG_NICINTEL CONFIG_NICINTEL_SPI)
290$(call mark_unsupported,CONFIG_NICINTEL_EEPROM CONFIG_OGP_SPI CONFIG_IT8212)
Carl-Daniel Hailfinger8d0d53f2016-02-25 20:10:26 +0000291endif
292
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000293###############################################################################
294# Flash chip drivers and bus support infrastructure.
295
Stefan Tauner4404f732013-09-12 08:28:56 +0000296CHIP_OBJS = jedec.o stm50.o w39.o w29ee011.o \
Carl-Daniel Hailfingera8cf3622014-08-08 08:33:01 +0000297 sst28sf040.o 82802ab.o \
Paul Kocialkowski80ae14e2018-01-15 01:07:46 +0300298 sst49lfxxxc.o sst_fwhub.o edi.o flashchips.o spi.o spi25.o spi25_statusreg.o \
Nikolai Artemievc9feb1b2021-10-21 01:35:13 +1100299 spi95.o opaque.o sfdp.o en29lv640b.o at45db.o \
300 writeprotect.o writeprotect_ranges.o
Sean Nelson5d134642009-12-24 16:54:21 +0000301
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000302###############################################################################
303# Library code.
Sean Nelson5d134642009-12-24 16:54:21 +0000304
Thomas Heijligenbbfacff2021-03-31 20:40:01 +0200305LIB_OBJS = libflashrom.o layout.o flashrom.o udelay.o programmer.o programmer_table.o helpers.o ich_descriptors.o fmap.o
Sean Nelson5d134642009-12-24 16:54:21 +0000306
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000307###############################################################################
308# Frontend related stuff.
Ollie Lho184a4042005-11-26 21:55:36 +0000309
Stefan Tauner9b32de92014-08-08 23:52:33 +0000310CLI_OBJS = cli_classic.o cli_output.o cli_common.o print.o
Ollie Lho184a4042005-11-26 21:55:36 +0000311
Stefan Taunerfa25bc32017-10-04 03:47:26 +0200312# versioninfo.inc stores metadata required to build a packaged flashrom. It is generated by the export rule and
313# imported below. If versioninfo.inc is not found and the variables are not defined by the user, the info will
314# be obtained using util/getrevision.sh, which is the common case during development.
315-include versioninfo.inc
Stefan Tauner5bf6b852017-10-04 03:46:51 +0200316VERSION ?= $(shell ./util/getrevision.sh --revision)
Stefan Tauner96209122017-10-01 16:41:35 +0200317MAN_DATE ?= $(shell ./util/getrevision.sh --date $(PROGRAM).8.tmpl 2>/dev/null)
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +0000318
Stefan Tauner76347082016-11-27 17:45:49 +0100319SCMDEF := -D'FLASHROM_VERSION="$(VERSION)"'
Bernhard Walle201bde32008-01-21 15:24:22 +0000320
Stefan Tauner76347082016-11-27 17:45:49 +0100321# Inform user of the version string
Nico Huber26c2c4d2023-01-10 17:45:38 +0100322ifeq ($(filter branch tag,$(MAKECMDGOALS)), )
Stefan Tauner76347082016-11-27 17:45:49 +0100323$(info Replacing all version templates with $(VERSION).)
Nico Huber26c2c4d2023-01-10 17:45:38 +0100324endif
Stefan Taunerd5ff8452015-01-10 09:32:07 +0000325
Stefan Tauner037cd842013-08-25 00:10:56 +0000326###############################################################################
327# Default settings of CONFIG_* variables.
328
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000329# Always enable internal/onboard support for now.
330CONFIG_INTERNAL ?= yes
331
Stefan Tauner52b6e9d2013-04-01 00:46:05 +0000332# Always enable serprog for now.
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000333CONFIG_SERPROG ?= yes
334
Carl-Daniel Hailfingere7fdd6e2010-07-21 10:26:01 +0000335# RayeR SPIPGM hardware support
336CONFIG_RAYER_SPI ?= yes
337
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000338# PonyProg2000 SPI hardware support
339CONFIG_PONY_SPI ?= yes
340
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000341# Always enable 3Com NICs for now.
342CONFIG_NIC3COM ?= yes
343
Carl-Daniel Hailfingerbf3af292010-07-29 14:41:46 +0000344# Enable NVIDIA graphics cards. Note: write and erase do not work properly.
345CONFIG_GFXNVIDIA ?= yes
Uwe Hermann2bc98f62009-09-30 18:29:55 +0000346
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000347# Always enable SiI SATA controllers for now.
348CONFIG_SATASII ?= yes
349
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000350# Highpoint (HPT) ATA/RAID controller support.
351# IMPORTANT: This code is not yet working!
352CONFIG_ATAHPT ?= no
353
Jonathan Kollasch7f0f3fa2014-06-01 10:26:23 +0000354# VIA VT6421A LPC memory support
355CONFIG_ATAVIA ?= yes
356
Joseph C. Lehnerc2644a32016-01-16 23:45:25 +0000357# Promise ATA controller support.
358CONFIG_ATAPROMISE ?= no
359
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000360# Always enable FT2232 SPI dongles for now.
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000361CONFIG_FT2232_SPI ?= yes
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000362
James Lairdc60de0e2013-03-27 13:00:23 +0000363# Always enable Altera USB-Blaster dongles for now.
364CONFIG_USBBLASTER_SPI ?= yes
365
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000366# MSTAR DDC support needs more tests/reviews/cleanups.
367CONFIG_MSTARDDC_SPI ?= no
368
Justin Chevrier66e554b2015-02-08 21:58:10 +0000369# Always enable PICkit2 SPI dongles for now.
370CONFIG_PICKIT2_SPI ?= yes
371
Miklós Márton324929c2019-08-01 19:14:10 +0200372# Always enable STLink V3
373CONFIG_STLINKV3_SPI ?= yes
374
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000375# Always enable dummy tracing for now.
376CONFIG_DUMMY ?= yes
377
378# Always enable Dr. Kaiser for now.
379CONFIG_DRKAISER ?= yes
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000380
Joerg Fischer5665ef32010-05-21 21:54:07 +0000381# Always enable Realtek NICs for now.
382CONFIG_NICREALTEK ?= yes
383
Andrew Morganc29c2e72010-06-07 22:37:54 +0000384# Disable National Semiconductor NICs until support is complete and tested.
385CONFIG_NICNATSEMI ?= no
386
Carl-Daniel Hailfingerb713d2e2011-05-08 00:24:18 +0000387# Always enable Intel NICs for now.
388CONFIG_NICINTEL ?= yes
389
Idwer Vollering004f4b72010-09-03 18:21:21 +0000390# Always enable SPI on Intel NICs for now.
391CONFIG_NICINTEL_SPI ?= yes
392
Ricardo Ribalda Delgado2a41f0a2014-07-28 20:35:21 +0000393# Always enable EEPROM on Intel NICs for now.
394CONFIG_NICINTEL_EEPROM ?= yes
395
Mark Marshall90021f22010-12-03 14:48:11 +0000396# Always enable SPI on OGP cards for now.
397CONFIG_OGP_SPI ?= yes
398
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000399# Always enable Bus Pirate SPI for now.
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000400CONFIG_BUSPIRATE_SPI ?= yes
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000401
Simon Glassae616512016-01-23 23:27:58 +0000402# Always enable Dediprog SF100 for now.
403CONFIG_DEDIPROG ?= yes
Carl-Daniel Hailfingerd38fac82010-01-19 11:15:48 +0000404
Daniel Thompson45e91a22018-06-04 13:46:29 +0100405# Always enable Developerbox emergency recovery for now.
406CONFIG_DEVELOPERBOX_SPI ?= yes
407
Carl-Daniel Hailfinger9a1105c2011-02-04 21:37:59 +0000408# Always enable Marvell SATA controllers for now.
409CONFIG_SATAMV ?= yes
410
David Hendricksf9a30552015-05-23 20:30:30 -0700411# Enable Linux spidev and MTD interfaces by default. We disable them on non-Linux targets.
412CONFIG_LINUX_MTD ?= yes
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000413CONFIG_LINUX_SPI ?= yes
414
Kyösti Mälkki72d42f82014-06-01 23:48:31 +0000415# Always enable ITE IT8212F PATA controllers for now.
416CONFIG_IT8212 ?= yes
417
Urja Rannikko0870b022016-01-31 22:10:29 +0000418# Winchiphead CH341A
419CONFIG_CH341A_SPI ?= yes
420
Lubomir Rintelb2154e82018-01-14 17:35:33 +0100421# Digilent Development board JTAG
422CONFIG_DIGILENT_SPI ?= yes
423
Jean THOMASe28d8e42022-10-11 17:54:30 +0200424# DirtyJTAG
425CONFIG_DIRTYJTAG_SPI ?= yes
426
Marc Schink3578ec62016-03-17 16:23:03 +0100427# Disable J-Link for now.
428CONFIG_JLINK_SPI ?= no
429
Nico Huber83d52072021-06-27 00:07:13 +0200430# National Instruments USB-845x is Windows only and needs a proprietary library.
431CONFIG_NI845X_SPI ?= no
432
Carl-Daniel Hailfinger6161ff12009-11-16 21:22:24 +0000433# Disable wiki printing by default. It is only useful if you have wiki access.
Uwe Hermann2db77a02010-06-04 17:07:39 +0000434CONFIG_PRINT_WIKI ?= no
Carl-Daniel Hailfinger9c8476b2009-09-16 12:19:03 +0000435
Stefan Taunerf3503372016-02-26 23:51:21 +0000436# Disable all features if CONFIG_NOTHING=yes is given unless CONFIG_EVERYTHING was also set
437ifeq ($(CONFIG_NOTHING), yes)
438 ifeq ($(CONFIG_EVERYTHING), yes)
439 $(error Setting CONFIG_NOTHING=yes and CONFIG_EVERYTHING=yes does not make sense)
440 endif
441 $(foreach var, $(filter CONFIG_%, $(.VARIABLES)),\
442 $(if $(filter yes, $($(var))),\
443 $(eval $(var)=no)))
444endif
445
Patrick Georgiced7ab62015-01-19 19:52:34 +0000446# Enable all features if CONFIG_EVERYTHING=yes is given
447ifeq ($(CONFIG_EVERYTHING), yes)
448$(foreach var, $(filter CONFIG_%, $(.VARIABLES)),\
449 $(if $(filter no, $($(var))),\
450 $(eval $(var)=yes)))
451endif
452
Carl-Daniel Hailfinger9e3a6c42010-10-08 12:40:09 +0000453# Bitbanging SPI infrastructure, default off unless needed.
Nico Huber29c68342021-06-27 14:34:16 +0200454
455ifneq ($(call filter_deps,$(DEPENDS_ON_BITBANG_SPI)), )
Felix Singer4cbc1cb2022-07-22 23:23:28 +0200456override CONFIG_BITBANG_SPI = yes
457else
Carl-Daniel Hailfinger9e3a6c42010-10-08 12:40:09 +0000458CONFIG_BITBANG_SPI ?= no
459endif
Carl-Daniel Hailfinger9e3a6c42010-10-08 12:40:09 +0000460
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000461###############################################################################
Sean Nelson4c6d3a42013-09-11 23:35:03 +0000462# Handle CONFIG_* variables that depend on others set (and verified) above.
463
464# The external DMI decoder (dmidecode) does not work in libpayload. Bail out if the internal one got disabled.
465ifeq ($(TARGET_OS), libpayload)
466ifeq ($(CONFIG_INTERNAL), yes)
467ifeq ($(CONFIG_INTERNAL_DMI), no)
468UNSUPPORTED_FEATURES += CONFIG_INTERNAL_DMI=no
469else
470override CONFIG_INTERNAL_DMI = yes
471endif
472endif
473endif
474
475# Use internal DMI/SMBIOS decoder by default instead of relying on dmidecode.
476CONFIG_INTERNAL_DMI ?= yes
477
478###############################################################################
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000479# Programmer drivers and programmer support infrastructure.
Stefan Tauner037cd842013-08-25 00:10:56 +0000480# Depending on the CONFIG_* variables set and verified above we set compiler flags and parameters below.
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000481
Thomas Heijligen84e9c912021-06-01 16:22:14 +0200482ifdef CONFIG_DEFAULT_PROGRAMMER_NAME
483FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER_NAME=&programmer_$(CONFIG_DEFAULT_PROGRAMMER_NAME)'
484else
485FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER_NAME=NULL'
486endif
487
Stefan Tauner265fcac2014-06-02 00:12:23 +0000488FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER_ARGS="$(CONFIG_DEFAULT_PROGRAMMER_ARGS)"'
Stefan Taunerfd0d4132012-09-25 21:24:55 +0000489
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000490ifeq ($(CONFIG_INTERNAL), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000491FEATURE_CFLAGS += -D'CONFIG_INTERNAL=1'
Sean Nelson4c6d3a42013-09-11 23:35:03 +0000492PROGRAMMER_OBJS += processor_enable.o chipset_enable.o board_enable.o cbtable.o internal.o
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000493ifeq ($(ARCH), x86)
Edward O'Callaghan2ab6bba2022-06-24 16:48:09 +1000494PROGRAMMER_OBJS += it87spi.o sb600spi.o amd_imc.o wbsio_spi.o mcp6x_spi.o
Nico Huber305f4172013-06-14 11:55:26 +0200495PROGRAMMER_OBJS += ichspi.o dmi.o
Sean Nelson4c6d3a42013-09-11 23:35:03 +0000496ifeq ($(CONFIG_INTERNAL_DMI), yes)
497FEATURE_CFLAGS += -D'CONFIG_INTERNAL_DMI=1'
498endif
Carl-Daniel Hailfinger91199a12011-07-07 06:59:18 +0000499else
500endif
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000501endif
502
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000503ifeq ($(CONFIG_SERPROG), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000504FEATURE_CFLAGS += -D'CONFIG_SERPROG=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000505PROGRAMMER_OBJS += serprog.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000506NEED_SERIAL += CONFIG_SERPROG
507NEED_POSIX_SOCKETS += CONFIG_SERPROG
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000508endif
509
Carl-Daniel Hailfingere7fdd6e2010-07-21 10:26:01 +0000510ifeq ($(CONFIG_RAYER_SPI), yes)
511FEATURE_CFLAGS += -D'CONFIG_RAYER_SPI=1'
512PROGRAMMER_OBJS += rayer_spi.o
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000513NEED_RAW_ACCESS += CONFIG_RAYER_SPI
Carl-Daniel Hailfingere7fdd6e2010-07-21 10:26:01 +0000514endif
515
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000516ifeq ($(CONFIG_PONY_SPI), yes)
517FEATURE_CFLAGS += -D'CONFIG_PONY_SPI=1'
518PROGRAMMER_OBJS += pony_spi.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000519NEED_SERIAL += CONFIG_PONY_SPI
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000520endif
521
Carl-Daniel Hailfinger547872b2009-09-28 13:15:16 +0000522ifeq ($(CONFIG_BITBANG_SPI), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000523FEATURE_CFLAGS += -D'CONFIG_BITBANG_SPI=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000524PROGRAMMER_OBJS += bitbang_spi.o
Carl-Daniel Hailfinger547872b2009-09-28 13:15:16 +0000525endif
526
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000527ifeq ($(CONFIG_NIC3COM), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000528FEATURE_CFLAGS += -D'CONFIG_NIC3COM=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000529PROGRAMMER_OBJS += nic3com.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000530endif
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000531
Uwe Hermann2bc98f62009-09-30 18:29:55 +0000532ifeq ($(CONFIG_GFXNVIDIA), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000533FEATURE_CFLAGS += -D'CONFIG_GFXNVIDIA=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000534PROGRAMMER_OBJS += gfxnvidia.o
Uwe Hermann2bc98f62009-09-30 18:29:55 +0000535endif
536
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000537ifeq ($(CONFIG_SATASII), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000538FEATURE_CFLAGS += -D'CONFIG_SATASII=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000539PROGRAMMER_OBJS += satasii.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000540endif
541
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000542ifeq ($(CONFIG_ATAHPT), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000543FEATURE_CFLAGS += -D'CONFIG_ATAHPT=1'
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000544PROGRAMMER_OBJS += atahpt.o
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000545endif
546
Jonathan Kollasch7f0f3fa2014-06-01 10:26:23 +0000547ifeq ($(CONFIG_ATAVIA), yes)
548FEATURE_CFLAGS += -D'CONFIG_ATAVIA=1'
549PROGRAMMER_OBJS += atavia.o
Jonathan Kollasch7f0f3fa2014-06-01 10:26:23 +0000550endif
551
Joseph C. Lehnerc2644a32016-01-16 23:45:25 +0000552ifeq ($(CONFIG_ATAPROMISE), yes)
553FEATURE_CFLAGS += -D'CONFIG_ATAPROMISE=1'
554PROGRAMMER_OBJS += atapromise.o
Joseph C. Lehnerc2644a32016-01-16 23:45:25 +0000555endif
556
Kyösti Mälkki72d42f82014-06-01 23:48:31 +0000557ifeq ($(CONFIG_IT8212), yes)
558FEATURE_CFLAGS += -D'CONFIG_IT8212=1'
559PROGRAMMER_OBJS += it8212.o
Kyösti Mälkki72d42f82014-06-01 23:48:31 +0000560endif
561
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000562ifeq ($(CONFIG_FT2232_SPI), yes)
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000563# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000564FEATURE_CFLAGS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "-D'CONFIG_FT2232_SPI=1'")
James Lairdc60de0e2013-03-27 13:00:23 +0000565PROGRAMMER_OBJS += ft2232_spi.o
566endif
567
568ifeq ($(CONFIG_USBBLASTER_SPI), yes)
569# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000570FEATURE_CFLAGS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "-D'CONFIG_USBBLASTER_SPI=1'")
James Lairdc60de0e2013-03-27 13:00:23 +0000571PROGRAMMER_OBJS += usbblaster_spi.o
572endif
573
Justin Chevrier66e554b2015-02-08 21:58:10 +0000574ifeq ($(CONFIG_PICKIT2_SPI), yes)
575FEATURE_CFLAGS += -D'CONFIG_PICKIT2_SPI=1'
576PROGRAMMER_OBJS += pickit2_spi.o
Justin Chevrier66e554b2015-02-08 21:58:10 +0000577endif
578
Miklós Márton324929c2019-08-01 19:14:10 +0200579ifeq ($(CONFIG_STLINKV3_SPI), yes)
580FEATURE_CFLAGS += -D'CONFIG_STLINKV3_SPI=1'
581PROGRAMMER_OBJS += stlinkv3_spi.o
Miklós Márton324929c2019-08-01 19:14:10 +0200582endif
583
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000584ifeq ($(CONFIG_DUMMY), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000585FEATURE_CFLAGS += -D'CONFIG_DUMMY=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000586PROGRAMMER_OBJS += dummyflasher.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000587endif
588
589ifeq ($(CONFIG_DRKAISER), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000590FEATURE_CFLAGS += -D'CONFIG_DRKAISER=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000591PROGRAMMER_OBJS += drkaiser.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000592endif
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000593
Joerg Fischer5665ef32010-05-21 21:54:07 +0000594ifeq ($(CONFIG_NICREALTEK), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000595FEATURE_CFLAGS += -D'CONFIG_NICREALTEK=1'
Joerg Fischer5665ef32010-05-21 21:54:07 +0000596PROGRAMMER_OBJS += nicrealtek.o
Joerg Fischer5665ef32010-05-21 21:54:07 +0000597endif
598
Andrew Morganc29c2e72010-06-07 22:37:54 +0000599ifeq ($(CONFIG_NICNATSEMI), yes)
600FEATURE_CFLAGS += -D'CONFIG_NICNATSEMI=1'
601PROGRAMMER_OBJS += nicnatsemi.o
Andrew Morganc29c2e72010-06-07 22:37:54 +0000602endif
603
Carl-Daniel Hailfingerb713d2e2011-05-08 00:24:18 +0000604ifeq ($(CONFIG_NICINTEL), yes)
605FEATURE_CFLAGS += -D'CONFIG_NICINTEL=1'
606PROGRAMMER_OBJS += nicintel.o
Carl-Daniel Hailfingerb713d2e2011-05-08 00:24:18 +0000607endif
608
Idwer Vollering004f4b72010-09-03 18:21:21 +0000609ifeq ($(CONFIG_NICINTEL_SPI), yes)
610FEATURE_CFLAGS += -D'CONFIG_NICINTEL_SPI=1'
611PROGRAMMER_OBJS += nicintel_spi.o
Idwer Vollering004f4b72010-09-03 18:21:21 +0000612endif
613
Ricardo Ribalda Delgado2a41f0a2014-07-28 20:35:21 +0000614ifeq ($(CONFIG_NICINTEL_EEPROM), yes)
615FEATURE_CFLAGS += -D'CONFIG_NICINTEL_EEPROM=1'
616PROGRAMMER_OBJS += nicintel_eeprom.o
Ricardo Ribalda Delgado2a41f0a2014-07-28 20:35:21 +0000617endif
618
Mark Marshall90021f22010-12-03 14:48:11 +0000619ifeq ($(CONFIG_OGP_SPI), yes)
620FEATURE_CFLAGS += -D'CONFIG_OGP_SPI=1'
621PROGRAMMER_OBJS += ogp_spi.o
Mark Marshall90021f22010-12-03 14:48:11 +0000622endif
623
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000624ifeq ($(CONFIG_BUSPIRATE_SPI), yes)
625FEATURE_CFLAGS += -D'CONFIG_BUSPIRATE_SPI=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000626PROGRAMMER_OBJS += buspirate_spi.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000627NEED_SERIAL += CONFIG_BUSPIRATE_SPI
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000628endif
629
Carl-Daniel Hailfingerd38fac82010-01-19 11:15:48 +0000630ifeq ($(CONFIG_DEDIPROG), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000631FEATURE_CFLAGS += -D'CONFIG_DEDIPROG=1'
Carl-Daniel Hailfingerd38fac82010-01-19 11:15:48 +0000632PROGRAMMER_OBJS += dediprog.o
633endif
634
Daniel Thompson45e91a22018-06-04 13:46:29 +0100635ifeq ($(CONFIG_DEVELOPERBOX_SPI), yes)
636FEATURE_CFLAGS += -D'CONFIG_DEVELOPERBOX_SPI=1'
637PROGRAMMER_OBJS += developerbox_spi.o
Daniel Thompson45e91a22018-06-04 13:46:29 +0100638endif
639
Carl-Daniel Hailfinger9a1105c2011-02-04 21:37:59 +0000640ifeq ($(CONFIG_SATAMV), yes)
641FEATURE_CFLAGS += -D'CONFIG_SATAMV=1'
642PROGRAMMER_OBJS += satamv.o
Carl-Daniel Hailfinger9a1105c2011-02-04 21:37:59 +0000643endif
644
David Hendricksf9a30552015-05-23 20:30:30 -0700645ifeq ($(CONFIG_LINUX_MTD), yes)
646# This is a totally ugly hack.
647FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_MTD_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_LINUX_MTD=1'")
648PROGRAMMER_OBJS += linux_mtd.o
649endif
650
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000651ifeq ($(CONFIG_LINUX_SPI), yes)
Stefan Tauner8868db32012-03-13 00:18:19 +0000652# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000653FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_SPI_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_LINUX_SPI=1'")
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000654PROGRAMMER_OBJS += linux_spi.o
655endif
656
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000657ifeq ($(CONFIG_MSTARDDC_SPI), yes)
658# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000659FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_I2C_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_MSTARDDC_SPI=1'")
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000660NEED_LINUX_I2C += CONFIG_MSTARDDC_SPI
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000661PROGRAMMER_OBJS += mstarddc_spi.o
662endif
663
Urja Rannikko0870b022016-01-31 22:10:29 +0000664ifeq ($(CONFIG_CH341A_SPI), yes)
665FEATURE_CFLAGS += -D'CONFIG_CH341A_SPI=1'
666PROGRAMMER_OBJS += ch341a_spi.o
Urja Rannikko0870b022016-01-31 22:10:29 +0000667endif
668
Lubomir Rintelb2154e82018-01-14 17:35:33 +0100669ifeq ($(CONFIG_DIGILENT_SPI), yes)
670FEATURE_CFLAGS += -D'CONFIG_DIGILENT_SPI=1'
671PROGRAMMER_OBJS += digilent_spi.o
Lubomir Rintelb2154e82018-01-14 17:35:33 +0100672endif
673
Jean THOMASe28d8e42022-10-11 17:54:30 +0200674ifeq ($(CONFIG_DIRTYJTAG_SPI), yes)
675FEATURE_CFLAGS += -D'CONFIG_DIRTYJTAG_SPI=1'
676PROGRAMMER_OBJS += dirtyjtag_spi.o
677endif
678
Marc Schink3578ec62016-03-17 16:23:03 +0100679ifeq ($(CONFIG_JLINK_SPI), yes)
Marc Schink3578ec62016-03-17 16:23:03 +0100680FEATURE_CFLAGS += -D'CONFIG_JLINK_SPI=1'
681PROGRAMMER_OBJS += jlink_spi.o
682endif
683
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100684ifeq ($(CONFIG_NI845X_SPI), yes)
685FEATURE_CFLAGS += -D'CONFIG_NI845X_SPI=1'
686
687ifeq ($(CONFIG_NI845X_LIBRARY_PATH),)
688# if the user did not specified the NI-845x headers/lib path
689# do a guess for both 32 and 64 bit Windows versions
690NI845X_LIBS += -L'${PROGRAMFILES}\National Instruments\NI-845x\MS Visual C'
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100691NI845X_INCLUDES += -I'${PROGRAMFILES}\National Instruments\NI-845x\MS Visual C'
Miklós Mártonfea5aa12021-07-27 14:29:16 +0200692
693# hack to access env variable containing brackets...
694PROGRAMFILES_X86DIR = $(shell env | sed -n "s/^PROGRAMFILES(X86)=//p")
695
696ifneq ($(PROGRAMFILES_X86DIR),)
697ifneq ($(PROGRAMFILES_X86DIR), ${PROGRAMFILES})
698NI845X_LIBS += -L'$(PROGRAMFILES_X86DIR)\National Instruments\NI-845x\MS Visual C'
699NI845X_INCLUDES += -I'$(PROGRAMFILES_X86DIR)\National Instruments\NI-845x\MS Visual C'
700endif
701endif
702
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100703else
704NI845X_LIBS += -L'$(CONFIG_NI845X_LIBRARY_PATH)'
705NI845X_INCLUDES += -I'$(CONFIG_NI845X_LIBRARY_PATH)'
706endif
707
708FEATURE_CFLAGS += $(NI845X_INCLUDES)
709LIBS += -lni845x
710PROGRAMMER_OBJS += ni845x_spi.o
711endif
712
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000713ifneq ($(NEED_SERIAL), )
Thomas Heijligen140c1262021-09-27 15:12:26 +0200714LIB_OBJS += serial.o
715ifeq ($(TARGET_OS), Linux)
716LIB_OBJS += custom_baud_linux.o
717else
718LIB_OBJS += custom_baud.o
719endif
Carl-Daniel Hailfinger5bdf2982010-06-14 12:42:05 +0000720endif
721
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000722ifneq ($(NEED_POSIX_SOCKETS), )
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000723ifeq ($(TARGET_OS), SunOS)
Stefan Taunerfc3ecc22016-03-13 12:57:03 +0000724LIBS += -lsocket -lnsl
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000725endif
Carl-Daniel Hailfingere51ea102009-11-23 19:20:11 +0000726endif
727
Nico Huberf55ca202021-06-27 14:36:06 +0200728NEED_LIBPCI := $(call filter_deps,$(DEPENDS_ON_LIBPCI))
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000729ifneq ($(NEED_LIBPCI), )
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000730CHECK_LIBPCI = yes
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000731# This is a dirty hack, but it saves us from checking all PCI drivers and all platforms manually.
732# libpci may need raw memory, MSR or PCI port I/O on some platforms.
733# Individual drivers might have the same needs as well.
734NEED_RAW_ACCESS += $(NEED_LIBPCI)
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000735FEATURE_CFLAGS += -D'NEED_PCI=1'
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000736FEATURE_CFLAGS += $(call debug_shell,grep -q "OLD_PCI_GET_DEV := yes" .libdeps && printf "%s" "-D'OLD_PCI_GET_DEV=1'")
Stefan Tauner56734502015-02-08 21:58:04 +0000737
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000738PROGRAMMER_OBJS += pcidev.o
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000739ifeq ($(TARGET_OS), NetBSD)
Carl-Daniel Hailfinger460b2822010-06-04 23:24:57 +0000740# The libpci we want is called libpciutils on NetBSD and needs NetBSD libpci.
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000741PCILIBS += -lpciutils -lpci
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000742else
743PCILIBS += -lpci
744endif
745endif
746
747ifneq ($(NEED_RAW_ACCESS), )
748# Raw memory, MSR or PCI port I/O access.
749FEATURE_CFLAGS += -D'NEED_RAW_ACCESS=1'
750PROGRAMMER_OBJS += physmap.o hwaccess.o
751
752ifeq ($(TARGET_OS), NetBSD)
Nico Huber9245b882021-04-18 20:50:32 +0200753ifeq ($(ARCH), x86)
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000754PCILIBS += -l$(shell uname -p)
Nico Huber9245b882021-04-18 20:50:32 +0200755endif
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000756else
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000757ifeq ($(TARGET_OS), OpenBSD)
Nico Huber9245b882021-04-18 20:50:32 +0200758ifeq ($(ARCH), x86)
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000759PCILIBS += -l$(shell uname -m)
Nico Huber9245b882021-04-18 20:50:32 +0200760endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000761else
762ifeq ($(TARGET_OS), Darwin)
763# DirectHW framework can be found in the DirectHW library.
Stefan Taunere34e3e82013-01-01 00:06:51 +0000764PCILIBS += -framework IOKit -framework DirectHW
Carl-Daniel Hailfingerb63b0672010-07-02 17:12:50 +0000765endif
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000766endif
Jonathan A. Kollasch3646c8f2010-01-08 21:18:08 +0000767endif
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000768
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000769endif
770
Nico Huberf55ca202021-06-27 14:36:06 +0200771NEED_LIBUSB1 := $(call filter_deps,$(DEPENDS_ON_LIBUSB1))
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000772ifneq ($(NEED_LIBUSB1), )
Stefan Taunere49edbb2016-01-31 22:10:14 +0000773CHECK_LIBUSB1 = yes
Daniel Thompson1d507a02018-07-12 11:02:28 +0100774PROGRAMMER_OBJS += usbdev.o
Stefan Taunere49edbb2016-01-31 22:10:14 +0000775# FreeBSD and DragonflyBSD use a reimplementation of libusb-1.0 that is simply called libusb
776ifeq ($(TARGET_OS),$(filter $(TARGET_OS),FreeBSD DragonFlyBSD))
777USB1LIBS += -lusb
778else
779ifeq ($(TARGET_OS),NetBSD)
Stefan Tauner45207062016-02-19 08:17:24 +0000780override CPPFLAGS += -I/usr/pkg/include/libusb-1.0
Stefan Taunere49edbb2016-01-31 22:10:14 +0000781USB1LIBS += -lusb-1.0
782else
Stefan Tauner45207062016-02-19 08:17:24 +0000783USB1LIBS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --libs libusb-1.0 || printf "%s" "-lusb-1.0")
784override CPPFLAGS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --cflags-only-I libusb-1.0 || printf "%s" "-I/usr/include/libusb-1.0")
Stefan Taunere49edbb2016-01-31 22:10:14 +0000785endif
786endif
787endif
788
Nico Huberf55ca202021-06-27 14:36:06 +0200789NEED_LIBFTDI := $(call filter_deps,$(DEPENDS_ON_LIBFTDI))
Nico Huber09e82e22021-06-27 14:31:37 +0200790ifneq ($(NEED_LIBFTDI), )
791FTDILIBS := $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)" ; $(PKG_CONFIG) --libs libftdi1 || $(PKG_CONFIG) --libs libftdi || printf "%s" "-lftdi -lusb")
792FEATURE_CFLAGS += $(call debug_shell,grep -q "FT232H := yes" .features && printf "%s" "-D'HAVE_FT232H=1'")
793FTDI_INCLUDES := $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)" ; $(PKG_CONFIG) --cflags-only-I libftdi1)
794FEATURE_CFLAGS += $(FTDI_INCLUDES)
795FEATURE_LIBS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "$(FTDILIBS)")
796# We can't set NEED_LIBUSB1 here because that would transform libftdi auto-enabling
797# into a hard requirement for libusb, defeating the purpose of auto-enabling.
798endif
799
Nico Huberf55ca202021-06-27 14:36:06 +0200800NEED_LIBJAYLINK := $(call filter_deps,$(DEPENDS_ON_LIBJAYLINK))
Marc Schink3578ec62016-03-17 16:23:03 +0100801ifneq ($(NEED_LIBJAYLINK), )
802CHECK_LIBJAYLINK = yes
803JAYLINKLIBS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --libs libjaylink)
804override CPPFLAGS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --cflags-only-I libjaylink)
805endif
806
Carl-Daniel Hailfinger9c8476b2009-09-16 12:19:03 +0000807ifeq ($(CONFIG_PRINT_WIKI), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000808FEATURE_CFLAGS += -D'CONFIG_PRINT_WIKI=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000809CLI_OBJS += print_wiki.o
Carl-Daniel Hailfinger9c8476b2009-09-16 12:19:03 +0000810endif
811
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000812FEATURE_CFLAGS += $(call debug_shell,grep -q "UTSNAME := yes" .features && printf "%s" "-D'HAVE_UTSNAME=1'")
Carl-Daniel Hailfinger132e2ec2010-03-27 16:36:40 +0000813
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +0000814# We could use PULLED_IN_LIBS, but that would be ugly.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000815FEATURE_LIBS += $(call debug_shell,grep -q "NEEDLIBZ := yes" .libdeps && printf "%s" "-lz")
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +0000816
Nico Huber8624e8c2012-11-05 21:46:33 +0100817FEATURE_CFLAGS += $(call debug_shell,grep -q "CLOCK_GETTIME := yes" .features && printf "%s" "-D'HAVE_CLOCK_GETTIME=1'")
818FEATURE_LIBS += $(call debug_shell,grep -q "CLOCK_GETTIME := yes" .features && printf "%s" "-lrt")
819
Patrick Georgi97bc95c2011-03-08 07:17:44 +0000820LIBFLASHROM_OBJS = $(CHIP_OBJS) $(PROGRAMMER_OBJS) $(LIB_OBJS)
Stefan Taunerd94d25d2012-07-28 03:17:15 +0000821OBJS = $(CLI_OBJS) $(LIBFLASHROM_OBJS)
Sean Nelson5d134642009-12-24 16:54:21 +0000822
Joerg Mayera93d9dc2013-08-29 00:38:19 +0000823all: hwlibs features $(PROGRAM)$(EXEC_SUFFIX) $(PROGRAM).8
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000824ifeq ($(ARCH), x86)
825 @+$(MAKE) -C util/ich_descriptors_tool/ TARGET_OS=$(TARGET_OS) EXEC_SUFFIX=$(EXEC_SUFFIX)
826endif
827
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000828$(PROGRAM)$(EXEC_SUFFIX): $(OBJS)
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100829 $(CC) $(LDFLAGS) -o $(PROGRAM)$(EXEC_SUFFIX) $(OBJS) $(LIBS) $(PCILIBS) $(FEATURE_LIBS) $(USBLIBS) $(USB1LIBS) $(JAYLINKLIBS) $(NI845X_LIBS)
Ronald G. Minnich5e5f75e2002-01-29 18:21:41 +0000830
Patrick Georgi97bc95c2011-03-08 07:17:44 +0000831libflashrom.a: $(LIBFLASHROM_OBJS)
832 $(AR) rcs $@ $^
833 $(RANLIB) $@
834
Carl-Daniel Hailfinger8ef7dce2009-07-10 20:19:48 +0000835# TAROPTIONS reduces information leakage from the packager's system.
836# If other tar programs support command line arguments for setting uid/gid of
837# stored files, they can be handled here as well.
838TAROPTIONS = $(shell LC_ALL=C tar --version|grep -q GNU && echo "--owner=root --group=root")
Carl-Daniel Hailfingerb18ecbc2009-06-19 14:20:34 +0000839
Paul Fox05dfbe62009-06-16 21:08:06 +0000840%.o: %.c .features
Stefan Tauner76347082016-11-27 17:45:49 +0100841 $(CC) -MMD $(CFLAGS) $(CPPFLAGS) $(FLASHROM_CFLAGS) $(FEATURE_CFLAGS) $(SCMDEF) -o $@ -c $<
Clark Rawlins02016f72008-02-14 23:22:20 +0000842
Carl-Daniel Hailfingera0020df2010-05-30 22:35:14 +0000843# Make sure to add all names of generated binaries here.
844# This includes all frontends and libflashrom.
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000845# We don't use EXEC_SUFFIX here because we want to clean everything.
Ronald G. Minnich5e5f75e2002-01-29 18:21:41 +0000846clean:
Stefan Tauner4c723152016-01-14 22:47:55 +0000847 rm -f $(PROGRAM) $(PROGRAM).exe libflashrom.a *.o *.d $(PROGRAM).8 $(PROGRAM).8.html $(BUILD_DETAILS_FILE)
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000848 @+$(MAKE) -C util/ich_descriptors_tool/ clean
Ronald G. Minnicheaab50b2003-09-12 22:41:53 +0000849
Ollie Lho184a4042005-11-26 21:55:36 +0000850distclean: clean
Stefan Reinauere2f01582010-06-07 11:08:07 +0000851 rm -f .features .libdeps
Christian Ruppertdb9d9f42009-05-14 14:17:07 +0000852
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000853strip: $(PROGRAM)$(EXEC_SUFFIX)
854 $(STRIP) $(STRIP_ARGS) $(PROGRAM)$(EXEC_SUFFIX)
Ronald G. Minnicheaab50b2003-09-12 22:41:53 +0000855
Stefan Tauner56787082011-08-18 02:27:19 +0000856# to define test programs we use verbatim variables, which get exported
857# to environment variables and are referenced with $$<varname> later
858
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +0000859compiler: featuresavailable
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000860 @printf "Checking for a C compiler... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +0000861 @echo "$$COMPILER_TEST" > .test.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000862 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .test.c -o .test$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000863 @{ { { { { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .test.c -o .test$(EXEC_SUFFIX) >&2 && \
864 echo "found." || { echo "not found."; \
865 rm -f .test.c .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000866 @rm -f .test.c .test$(EXEC_SUFFIX)
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000867 @printf "Target arch is "
Carl-Daniel Hailfinger91199a12011-07-07 06:59:18 +0000868 @# FreeBSD wc will output extraneous whitespace.
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000869 @echo $(ARCH)|wc -w|grep -q '^[[:blank:]]*1[[:blank:]]*$$' || \
Pyry Kontio89cc73b2020-07-06 12:57:35 +0900870 ( echo "unknown (\"$(ARCH)\"). Aborting."; exit 1)
Carl-Daniel Hailfinger91199a12011-07-07 06:59:18 +0000871 @printf "%s\n" '$(ARCH)'
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000872 @printf "Target OS is "
873 @# FreeBSD wc will output extraneous whitespace.
874 @echo $(TARGET_OS)|wc -w|grep -q '^[[:blank:]]*1[[:blank:]]*$$' || \
Pyry Kontio89cc73b2020-07-06 12:57:35 +0900875 ( echo "unknown (\"$(TARGET_OS)\"). Aborting."; exit 1)
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000876 @printf "%s\n" '$(TARGET_OS)'
Stefan Taunerd6c17f62013-09-12 14:04:31 +0000877ifeq ($(TARGET_OS), libpayload)
878 @$(CC) --version 2>&1 | grep -q coreboot || \
879 ( echo "Warning: It seems you are not using coreboot's reference compiler."; \
880 echo "This might work but usually does not, please beware." )
881endif
Carl-Daniel Hailfinger4cb7a962009-06-16 09:31:51 +0000882
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000883hwlibs: compiler
884 @printf "" > .libdeps
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000885ifeq ($(CHECK_LIBPCI), yes)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000886 @printf "Checking for libpci headers... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +0000887 @echo "$$LIBPCI_TEST" > .test.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000888 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000889 @{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
890 echo "found." || { echo "not found."; echo; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000891 echo "The following features require libpci: $(NEED_LIBPCI)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +0000892 echo "Please install libpci headers or disable all features"; \
893 echo "mentioned above by specifying make CONFIG_ENABLE_LIBPCI_PROGRAMMERS=no"; \
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +0000894 echo "See README for more information."; echo; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000895 rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
896 @printf "Checking version of pci_get_dev... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56734502015-02-08 21:58:04 +0000897 @echo "$$PCI_GET_DEV_TEST" > .test.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000898 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000899 @ { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
Stefan Tauner56734502015-02-08 21:58:04 +0000900 ( echo "new version (including PCI domain parameter)."; echo "OLD_PCI_GET_DEV := no" >> .libdeps ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000901 ( echo "old version (without PCI domain parameter)."; echo "OLD_PCI_GET_DEV := yes" >> .libdeps ) } 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
902 @printf "Checking if libpci is present and sufficient... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000903 @printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000904 @{ { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) 2>>$(BUILD_DETAILS_FILE) >&2 && \
905 echo "yes." || { echo "no."; \
906 printf "Checking if libz+libpci are present and sufficient..." ; \
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000907 { printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) -lz" >>$(BUILD_DETAILS_FILE) ; \
908 $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) -lz >&2 && \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000909 echo "yes." && echo "NEEDLIBZ := yes" > .libdeps } || { echo "no."; echo; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000910 echo "The following features require libpci: $(NEED_LIBPCI)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +0000911 echo "Please install libpci (package pciutils) and/or libz or disable all features"; \
912 echo "mentioned above by specifying make CONFIG_ENABLE_LIBPCI_PROGRAMMERS=no"; \
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +0000913 echo "See README for more information."; echo; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000914 rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000915 @rm -f .test.c .test.o .test$(EXEC_SUFFIX)
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000916endif
Stefan Taunere49edbb2016-01-31 22:10:14 +0000917ifeq ($(CHECK_LIBUSB1), yes)
918 @printf "Checking for libusb-1.0 headers... " | tee -a $(BUILD_DETAILS_FILE)
919 @echo "$$LIBUSB1_TEST" > .test.c
920 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
921 @{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
922 echo "found." || { echo "not found."; echo; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000923 echo "The following features require libusb-1.0: $(NEED_LIBUSB1)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +0000924 echo "Please install libusb-1.0 headers or disable all features"; \
925 echo "mentioned above by specifying make CONFIG_ENABLE_LIBUSB1_PROGRAMMERS=no"; \
Stefan Taunere49edbb2016-01-31 22:10:14 +0000926 echo "See README for more information."; echo; \
927 rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
928 @printf "Checking if libusb-1.0 is usable... " | tee -a $(BUILD_DETAILS_FILE)
929 @printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(USB1LIBS)" >>$(BUILD_DETAILS_FILE)
930 @{ { { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(USB1LIBS) >&2 && \
931 echo "yes." || { echo "no."; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000932 echo "The following features require libusb-1.0: $(NEED_LIBUSB1)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +0000933 echo "Please install libusb-1.0 or disable all features"; \
934 echo "mentioned above by specifying make CONFIG_ENABLE_LIBUSB1_PROGRAMMERS=no"; \
Stefan Taunere49edbb2016-01-31 22:10:14 +0000935 echo "See README for more information."; echo; \
936 rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
937 @rm -f .test.c .test.o .test$(EXEC_SUFFIX)
938endif
Marc Schink3578ec62016-03-17 16:23:03 +0100939ifeq ($(CHECK_LIBJAYLINK), yes)
940 @printf "Checking for libjaylink headers... " | tee -a $(BUILD_DETAILS_FILE)
941 @echo "$$LIBJAYLINK_TEST" > .test.c
942 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
943 @{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
944 echo "found." || { echo "not found."; echo; \
945 echo "The following feature requires libjaylink: $(NEED_LIBJAYLINK)."; \
946 echo "Please install libjaylink headers or disable the feature"; \
947 echo "mentioned above by specifying make CONFIG_JLINK_SPI=no"; \
948 echo "See README for more information."; echo; \
949 rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
950 @printf "Checking if libjaylink is usable... " | tee -a $(BUILD_DETAILS_FILE)
951 @printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(JAYLINKLIBS)" >>$(BUILD_DETAILS_FILE)
952 @{ { { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(JAYLINKLIBS) >&2 && \
953 echo "yes." || { echo "no."; \
954 echo "The following feature requires libjaylink: $(NEED_LIBJAYLINK)."; \
955 echo "Please install libjaylink or disable the feature"; \
956 echo "mentioned above by specifying make CONFIG_JLINK_SPI=no"; \
957 echo "See README for more information."; echo; \
958 rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
959 @rm -f .test.c .test.o .test$(EXEC_SUFFIX)
960endif
Stefan Reinauer53e96252005-12-01 16:19:24 +0000961
Carl-Daniel Hailfingerb18ecbc2009-06-19 14:20:34 +0000962.features: features
963
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +0000964# If a user does not explicitly request a non-working feature, we should
965# silently disable it. However, if a non-working (does not compile) feature
966# is explicitly requested, we should bail out with a descriptive error message.
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000967# We also have to check that at least one programmer driver is enabled.
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +0000968featuresavailable:
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000969ifeq ($(PROGRAMMER_OBJS),)
970 @echo "You have to enable at least one programmer driver!"
971 @false
972endif
973ifneq ($(UNSUPPORTED_FEATURES), )
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +0000974 @echo "The following features are unavailable on your machine: $(UNSUPPORTED_FEATURES)"
975 @false
976endif
977
Carl-Daniel Hailfingerb18ecbc2009-06-19 14:20:34 +0000978features: compiler
979 @echo "FEATURES := yes" > .features.tmp
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000980ifneq ($(NEED_LIBFTDI), )
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000981 @printf "Checking for FTDI support... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +0000982 @echo "$$FTDI_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000983 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000984 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS) >&2 && \
985 ( echo "found."; echo "FTDISUPPORT := yes" >> .features.tmp ; \
986 printf "Checking for FT232H support in libftdi... " ; \
987 echo "$$FTDI_232H_TEST" >> .featuretest.c ; \
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000988 printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS)" >>$(BUILD_DETAILS_FILE) ; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000989 { $(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS) >&2 && \
990 ( echo "found."; echo "FT232H := yes" >> .features.tmp ) || \
991 ( echo "not found."; echo "FT232H := no" >> .features.tmp ) } \
992 ) || \
993 ( echo "not found."; echo "FTDISUPPORT := no" >> .features.tmp ) } \
994 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Carl-Daniel Hailfinger8a59ff02009-12-24 03:33:11 +0000995endif
David Hendricksf9a30552015-05-23 20:30:30 -0700996ifeq ($(CONFIG_LINUX_MTD), yes)
997 @printf "Checking if Linux MTD headers are present... " | tee -a $(BUILD_DETAILS_FILE)
998 @echo "$$LINUX_MTD_TEST" > .featuretest.c
999 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
1000 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
1001 ( echo "yes."; echo "LINUX_MTD_SUPPORT := yes" >> .features.tmp ) || \
1002 ( echo "no."; echo "LINUX_MTD_SUPPORT := no" >> .features.tmp ) } \
1003 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
1004endif
Stefan Tauner8868db32012-03-13 00:18:19 +00001005ifeq ($(CONFIG_LINUX_SPI), yes)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001006 @printf "Checking if Linux SPI headers are present... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner8868db32012-03-13 00:18:19 +00001007 @echo "$$LINUX_SPI_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001008 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001009 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
Stefan Tauner8868db32012-03-13 00:18:19 +00001010 ( echo "yes."; echo "LINUX_SPI_SUPPORT := yes" >> .features.tmp ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001011 ( echo "no."; echo "LINUX_SPI_SUPPORT := no" >> .features.tmp ) } \
1012 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner8868db32012-03-13 00:18:19 +00001013endif
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001014ifneq ($(NEED_LINUX_I2C), )
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001015 @printf "Checking if Linux I2C headers are present... " | tee -a $(BUILD_DETAILS_FILE)
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001016 @echo "$$LINUX_I2C_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001017 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001018 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001019 ( echo "yes."; echo "LINUX_I2C_SUPPORT := yes" >> .features.tmp ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001020 ( echo "no."; echo "LINUX_I2C_SUPPORT := no" >> .features.tmp ) } \
1021 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001022endif
Miklós Márton2d20d6d2018-01-30 20:20:15 +01001023ifeq ($(CONFIG_NI845X_SPI), yes)
1024 @printf "Checking for NI USB-845x installation... " | tee -a $(BUILD_DETAILS_FILE)
1025 @echo "$$NI845X_TEST" > .featuretest.c
1026 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(NI845X_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(NI845X_LIBS) $(LIBS)" >>$(BUILD_DETAILS_FILE)
1027
1028 @ { { { { { $(CC) $(CPPFLAGS) $(CFLAGS) $(NI845X_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(NI845X_LIBS) $(LIBS) >&2 && \
1029 ( echo "yes."; echo "NI845X_SUPPORT := yes" >> .features.tmp ) || \
1030 { echo -e "\nUnable to find NI-845x headers or libraries."; \
1031 echo "Please pass the NI-845x library path to the make with the CONFIG_NI845X_LIBRARY_PATH parameter,"; \
1032 echo "or disable the NI-845x support by specifying make CONFIG_NI845X_SPI=no"; \
1033 echo "For the NI-845x 17.0 the library path is:"; \
1034 echo " On 32 bit systems: C:\Program Files)\National Instruments\NI-845x\MS Visual C"; \
1035 echo " On 64 bit systems: C:\Program Files (x86)\National Instruments\NI-845x\MS Visual C"; \
1036 exit 1; }; } \
1037 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
1038endif
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001039 @printf "Checking for utsname support... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +00001040 @echo "$$UTSNAME_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001041 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001042 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
Stefan Tauner56787082011-08-18 02:27:19 +00001043 ( echo "found."; echo "UTSNAME := yes" >> .features.tmp ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001044 ( echo "not found."; echo "UTSNAME := no" >> .features.tmp ) } 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Nico Huber8624e8c2012-11-05 21:46:33 +01001045 @printf "Checking for clock_gettime support... " | tee -a $(BUILD_DETAILS_FILE)
Martin Lucinac14e3f62020-12-18 14:11:04 +00001046ifeq ($(DISABLE_CLOCK_GETTIME), yes)
1047 @ { ( echo "disabled."; echo "CLOCK_GETTIME := no" >>.features.tmp ) } \
1048 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
1049else
Nico Huber8624e8c2012-11-05 21:46:33 +01001050 @echo "$$CLOCK_GETTIME_TEST" >.featuretest.c
1051 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -lrt .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
1052 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -lrt .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
1053 ( echo "found."; echo "CLOCK_GETTIME := yes" >>.features.tmp ) || \
1054 ( echo "not found."; echo "CLOCK_GETTIME := no" >>.features.tmp ) } \
1055 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Martin Lucinac14e3f62020-12-18 14:11:04 +00001056endif
Stefan Tauner56787082011-08-18 02:27:19 +00001057 @$(DIFF) -q .features.tmp .features >/dev/null 2>&1 && rm .features.tmp || mv .features.tmp .features
1058 @rm -f .featuretest.c .featuretest$(EXEC_SUFFIX)
Paul Fox05dfbe62009-06-16 21:08:06 +00001059
Stefan Tauner4c723152016-01-14 22:47:55 +00001060$(PROGRAM).8.html: $(PROGRAM).8
1061 @groff -mandoc -Thtml $< >$@
1062
Joerg Mayera93d9dc2013-08-29 00:38:19 +00001063$(PROGRAM).8: $(PROGRAM).8.tmpl
Stefan Tauner4c723152016-01-14 22:47:55 +00001064 @# Add the man page change date and version to the man page
Nico Huberac90af62022-12-18 00:22:47 +00001065 @sed -e 's#.TH FLASHROM 8 .*#.TH FLASHROM 8 "$(MAN_DATE)" "flashrom-stable-$(VERSION)" "$(MAN_DATE)"#' <$< >$@
Joerg Mayera93d9dc2013-08-29 00:38:19 +00001066
1067install: $(PROGRAM)$(EXEC_SUFFIX) $(PROGRAM).8
Uwe Hermannc2a9c9c2009-05-14 14:51:14 +00001068 mkdir -p $(DESTDIR)$(PREFIX)/sbin
Uwe Hermann56b2cb02009-05-21 15:59:58 +00001069 mkdir -p $(DESTDIR)$(MANDIR)/man8
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +00001070 $(INSTALL) -m 0755 $(PROGRAM)$(EXEC_SUFFIX) $(DESTDIR)$(PREFIX)/sbin
Uwe Hermann56b2cb02009-05-21 15:59:58 +00001071 $(INSTALL) -m 0644 $(PROGRAM).8 $(DESTDIR)$(MANDIR)/man8
Uwe Hermannc113b572006-12-14 00:59:41 +00001072
Nico Huber454f6132012-12-10 13:34:10 +00001073libinstall: libflashrom.a libflashrom.h
1074 mkdir -p $(DESTDIR)$(PREFIX)/lib
1075 $(INSTALL) -m 0644 libflashrom.a $(DESTDIR)$(PREFIX)/lib
1076 mkdir -p $(DESTDIR)$(PREFIX)/include
1077 $(INSTALL) -m 0644 libflashrom.h $(DESTDIR)$(PREFIX)/include
1078
Nico Huber5f245a22023-01-10 17:14:47 +01001079versioninfo:
1080# Generate versioninfo.inc containing metadata that would not be available in exported sources otherwise.
1081 @[ "$(RELEASE)" ] || { echo 'Error: Must provide `RELEASE=...`'; exit 1; }
1082 @echo "VERSION = $(RELEASE)" > $@.inc
1083 @echo "MAN_DATE = $(shell ./util/getrevision.sh --date $(PROGRAM).8.tmpl 2>/dev/null)" >> $@.inc
1084
Nico Huber26c2c4d2023-01-10 17:45:38 +01001085branch: versioninfo
1086 @git checkout -b $(RELEASE)
1087 @git add -f $<.inc
1088 @git commit -sm'Update version info for $(RELEASE)'
1089
1090tag: versioninfo
1091 @git add -f $<.inc
1092 @git commit -sm'Update version info for $(RELEASE)'
1093 @git tag -s $(RELEASE)
1094
Nico Huber5f245a22023-01-10 17:14:47 +01001095# No spaces in release names unless set explicitly
Nico Huber1d58a902023-01-10 18:26:12 +01001096RELEASENAME ?= flashrom-stable-$(shell echo "$(VERSION)" | sed -e 's/ /_/')
Nico Huber5f245a22023-01-10 17:14:47 +01001097
Nico Huber1d58a902023-01-10 18:26:12 +01001098_export: EXPORT_VERSIONINFO := $(EXPORTDIR)/$(RELEASENAME)/versioninfo.inc
Stefan Tauner76347082016-11-27 17:45:49 +01001099_export: $(PROGRAM).8
Nico Huber1d58a902023-01-10 18:26:12 +01001100 @rm -rf "$(EXPORTDIR)/$(RELEASENAME)"
1101 @mkdir -p "$(EXPORTDIR)/$(RELEASENAME)"
1102 @git archive HEAD | tar -x -C "$(EXPORTDIR)/$(RELEASENAME)"
Nico Huber5f245a22023-01-10 17:14:47 +01001103# Generate fresh versioninfo.inc and compare
1104 @echo "VERSION = $(shell ./util/getrevision.sh --revision)" > "$(EXPORT_VERSIONINFO)"
1105 @echo "MAN_DATE = $(shell ./util/getrevision.sh --date $(PROGRAM).8.tmpl 2>/dev/null)" >> \
1106 "$(EXPORT_VERSIONINFO)"
1107 @if [ -f versioninfo.inc ]; then \
1108 cmp -s versioninfo.inc "$(EXPORT_VERSIONINFO)" || \
1109 { echo Error: Version info changed:; \
1110 cat "$(EXPORT_VERSIONINFO)"; \
1111 echo Update versioninfo.inc and tag accordingly.; \
1112 exit 1; \
1113 }; \
1114 fi
Stefan Taunere4136852017-10-01 15:57:25 +02001115# Restore modification date of all tracked files not marked 'export-ignore' in .gitattributes.
1116# sed is required to filter out file names having the attribute set.
1117# The sed program saves the file name in the hold buffer and then checks if the respective value is 'set'.
1118# If so it ignores the rest of the program, which otherwise restores the file name and prints it.
Stefan Tauner76347082016-11-27 17:45:49 +01001119 @git ls-tree -r -z -t --full-name --name-only HEAD | \
1120 git check-attr -z --stdin export-ignore | \
Stefan Taunere4136852017-10-01 15:57:25 +02001121 sed -zne 'x;n;n;{/^set$$/b;};x;p;' | \
Stefan Tauner76347082016-11-27 17:45:49 +01001122 xargs -0 sh -c 'for f; do \
1123 touch -d $$(git log --pretty=format:%cI -1 HEAD -- "$$f") \
Nico Huber1d58a902023-01-10 18:26:12 +01001124 "$(EXPORTDIR)/$(RELEASENAME)/$$f"; \
Stefan Taunere4136852017-10-01 15:57:25 +02001125 done' dummy_arg0
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +00001126
Stefan Tauner76347082016-11-27 17:45:49 +01001127export: _export
Nico Huber1d58a902023-01-10 18:26:12 +01001128 @echo "Exported $(EXPORTDIR)/$(RELEASENAME)/"
Stefan Tauner76347082016-11-27 17:45:49 +01001129
1130tarball: _export
Nico Huber1d58a902023-01-10 18:26:12 +01001131 @tar -cj --format=ustar -f "$(EXPORTDIR)/$(RELEASENAME).tar.bz2" -C $(EXPORTDIR)/ \
1132 $(TAROPTIONS) "$(RELEASENAME)/"
Stefan Tauner76347082016-11-27 17:45:49 +01001133# Delete the exported directory again because it is most likely what's expected by the user.
Nico Huber1d58a902023-01-10 18:26:12 +01001134 @rm -rf "$(EXPORTDIR)/$(RELEASENAME)"
1135 @echo Created "$(EXPORTDIR)/$(RELEASENAME).tar.bz2"
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +00001136
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +00001137libpayload: clean
1138 make CC="CC=i386-elf-gcc lpgcc" AR=i386-elf-ar RANLIB=i386-elf-ranlib
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +00001139
Felix Singer9441c6e2022-10-21 12:47:11 +02001140gitconfig:
1141 ./util/getrevision.sh -c 2>/dev/null && ./util/git-hooks/install.sh
1142
Nico Huber26c2c4d2023-01-10 17:45:38 +01001143.PHONY: all install clean distclean compiler hwlibs features branch tag versioninfo _export export tarball featuresavailable libpayload gitconfig
Ollie Lho184a4042005-11-26 21:55:36 +00001144
Stefan Tauner23e10b82016-01-23 16:16:49 +00001145# Disable implicit suffixes and built-in rules (for performance and profit)
1146.SUFFIXES:
1147
Stefan Reinauere2f01582010-06-07 11:08:07 +00001148-include $(OBJS:.o=.d)